/* $Id: 38800.h,v 1.2 1998/11/02 04:38:33 brian Exp $
******************************************************************************

   ATI 38800 Series -- register definitions and macros

   Copyright (C) 1998		Brian S. Julin	[bri@forcade.calyx.com]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#ifndef _ATI_38800_h
#define _ATI_38800_h

#include <ATI/28800.h>

/* ATI accelerator tack-ons to the 8514 */

#define ATI_CONF_STAT_1r	0x12ee
	#define ATI_CSR1_CLK_MODE		0x0001
	#define ATI_CSR1_BUS_16			0x0002
	#define ATI_CSR1_MC_BUS			0x0004
	#define ATI_CSR1_EEPROM_ENA		0x0008
	#define ATI_CSR1_DRAM_ENA		0x0010
	#define ATI_CSR1_MEM_INSTALLED		0x0060
	#define ATI_CSR1_ROM_ENA		0x0080
	#define ATI_CSR1_ROM_PAGE_ENA		0x0100
	#define ATI_CSR1_ROM_LOCATION		0xfe00
#define ATI_CONF_STAT_2r	0x16ee
	#define ATI_CSR2_SHARE_CLOCK		0x0001
	#define ATI_CSR2_HIRES_BOOT		0x0002
	#define ATI_CSR2_EPROM_16_ENA		0x0004
	#define ATI_CSR2_WRITE_PER_BIT		0x0008
	#define ATI_CSR2_FLASH_ENA		0x0010
#define ATI_CRT_PITCH		0x26ee
#define ATI_CRT_OFFSET_LO	0x2aee
#define ATI_CRT_OFFSET_HI	0x2eee
	#define ATI_CRT_OFFSET_HI_MASK		0x000f
#define ATI_FIFO_OPTS		0x36ee
	#define ATI_FIFO_W_STATE_ENA		0x01
	#define ATI_FIFO_HOST_8_ENA		0x02
#define ATI_SHADOW_SET_CTL	0x46ee
	#define ATI_SHADOW_LOCK_CRT_PARAMS	0x0001
	#define ATI_SHADOW_LOCK_Y_CONTROL	0x0002
	#define ATI_SHADOW_LOCK_H_PARAMS	0x0004
	#define ATI_SHADOW_LOCK_H_DISP		0x0008
	#define ATI_SHADOW_LOCK_V_PARAMS	0x0010
	#define ATI_SHADOW_LOCK_V_DISP		0x0020
#define ATI_CLKSEL		0x4aee
	#define ATI_CLKSEL_PASS_THROUGH		0x00
	#define ATI_CLKSEL_MASK			0x00
	#define ATI_CLKSEL_DIV			0x00
	#define ATI_CLKSEL_REFRESH		0x00
	#define ATI_CLKSEL_VFIFO_DEPTH		0x00
	#define ATI_CLKSEL_COMPOSITE_SYNC	0x00
#define ATI_SHADOW_SET		0x5aee
	#define ATI_SHADOW_SET_MASK		0x0003
#define ATI_WSTATES		0x6aee
	#define ATI_WSTATES_Q			0x000f
	#define ATI_WSTATES_ROM			0x00f0
	#define ATI_WSTATES_LINE_OPT		0x0100
	#define ATI_IOR16_ENA			0x0200
	#define ATI_PASSTHROUGH_OVERRIDE	0x0400
#define ATI_GE_OFFSET_LO	0x6eee
#define ATI_BOUNDS_LEFT		0x72ee
#define ATI_GE_OFFSET_HI	0x72ee
	#define ATI_GE_OFFSET_HI_MASK		0x000f
#define ATI_BOUNDS_TOP		0x76ee
#define ATI_GE_PITCH		0x76ee
#define ATI_GE_CFG		0x7aee
	/* Fields in 8-bit mode */
	#define ATI_GE_EE_DATA_OUT		0x01
	#define ATI_GE_EE_CLK			0x02
	#define ATI_GE_EE_CS			0x04
	#define ATI_GE_ALIAS_ENA		0x08
	#define ATI_GE_Z1280			0x10
	#define ATI_GE_EE_SELECT		0x80
	/* Fields in 16-bit mode */
	#define ATI_GE_MONITOR_ALIAS		0x0007
	#define ATI_GE_ALIAS_ENA		0x0008
	#define ATI_GE_EE_DATA_OUT		0x1000
	#define ATI_GE_EE_CLK			0x2000
	#define ATI_GE_EE_ENA			0x4000
	#define ATI_GE_EE_SELECT		0x8000
#define ATI_BOUNDS_RIGHT	0x7aee
#define ATI_BOUNDS_BOTTOM	0x7eee
#define ATI_PATT_DAT_IDX	0x8200
#define ATI_PATT_DATA		0x8eee
#define ATI_BRESH_COUNT		0x96ee
#define ATI_FIFO_STAT		0x9aee
#define ATI_LINE_IDX		0x9aee
	#define ATI_LINE_IDX_CURRX_POLY		0x00
	#define ATI_LINE_IDX_CURRY_POLY		0x01
	#define ATI_LINE_IDX_ENDX		0x02
	#define ATI_LINE_IDX_ENDY		0x03
	#define ATI_LINE_IDX_CURRX		0x04
	#define ATI_LINE_IDX_CURRY		0x05
#define ATI_LINE_OPTS		0xa2ee
	#define ATI_LINE_POLY_MODE		0x0001
	#define ATI_LINE_LAST_PEL_OFF		0x0002
	#define ATI_LINE_DIR_TYPE		0x0004
	#define ATI_LINE_DEGREE			0x00e0
		#define ATI_LINE_0DEGREE		0x0000
		#define ATI_LINE_45DEGREE		0x0020
		#define ATI_LINE_90DEGREE		0x0040
		#define ATI_LINE_135DEGREE		0x0060
		#define ATI_LINE_180DEGREE		0x0080
		#define ATI_LINE_225DEGREE		0x00a0
		#define ATI_LINE_270DEGREE		0x00c0
		#define ATI_LINE_315DEGREE		0x00e0
	#define ATI_LINE_XDIR			0x0020
	#define ATI_LINE_YMAJOR			0x0040
	#define ATI_LINE_YDIR			0x0080
	#define ATI_LINE_BOUNDS_RESET		0x0100
	#define ATI_LINE_CLIP_MODE		0x0600
		#define ATI_LINE_CLIP_MODE_EXPT		0x0000
		#define ATI_LINE_CLIP_MODE_STROKE	0x0600
		#define ATI_LINE_CLIP_MODE_POLY		0x0600
		#define ATI_LINE_CLIP_MODE_PATT		0x0600
#define ATI_DEST_X_START	0xa6ee
#define ATI_DEST_X_END		0xaaee
#define ATI_DEST_Y_END		0xaeee
#define ATI_SRC_X_START		0xb2ee
#define ATI_ALU_BG_FN		0xb6ee
	#define ATI_ALU_BG_FN_MASK		0x03ff
#define ATI_ALU_FG_FN		0xbaee
	#define ATI_ALU_FG_FN_MASK		0x03ff
#define ATI_SRC_X_END		0xbeee
	#define ATI_SRC_X_END_MASK		0x03ff
#define ATI_SRC_Y_DIR		0xc2ee
#define ATI_SHORT_STROKE	0xc6ee
	#define ATI_STROKE_V0_LENGTH		0x000f
	#define ATI_STROKE_V0_MOVE		0x0010
	#define ATI_STROKE_V0_DIR		0x000e0
		#define ATI_STROKE_V0_0DEGREE		0x0000
		#define ATI_STROKE_V0_45DEGREE		0x0020
		#define ATI_STROKE_V0_90DEGREE		0x0040
		#define ATI_STROKE_V0_135DEGREE		0x0060
		#define ATI_STROKE_V0_180DEGREE		0x0080
		#define ATI_STROKE_V0_225DEGREE		0x00a0
		#define ATI_STROKE_V0_270DEGREE		0x00c0
		#define ATI_STROKE_V0_315DEGREE		0x00e0
	#define ATI_STROKE_V1_LENGTH		0x0f00
	#define ATI_STROKE_V1_MOVE		0x10
	#define ATI_STROKE_V1_DIR		0xe000
		#define ATI_STROKE_V1_0DEGREE		0x0000
		#define ATI_STROKE_V1_45DEGREE		0x2000
		#define ATI_STROKE_V1_90DEGREE		0x4000
		#define ATI_STROKE_V1_135DEGREE		0x6000
		#define ATI_STROKE_V1_180DEGREE		0x8000
		#define ATI_STROKE_V1_225DEGREE		0xa000
		#define ATI_STROKE_V1_270DEGREE		0xc000
		#define ATI_STROKE_V1_315DEGREE		0xe000
#define ATI_SCAN_TO_X		0xcaee
	#define ATI_SCAN_TO_X_MASK		0x03ff
#define ATI_DATA_PATH		0xceee
	#define ATI_GEDP_READ_WRITE		0x0001
	#define ATI_GEDP_POLY_FILL_MODE		0x0002
	#define ATI_GEDP_READ_MODE		0x0004
	#define ATI_GEDP_DRAW			0x0010
	#define ATI_GEDP_MONO_SRC		0x0060
		#define ATI_GEDP_MONO_SRC_HI		0x0000
		#define ATI_GEDP_MONO_SRC_PATT		0x0020
		#define ATI_GEDP_MONO_SRC_PTR		0x0040
		#define ATI_GEDP_MONO_SRC_VBLT		0x0060
	#define ATI_GEDP_BG_COLOR_SRC		0x0180
		#define ATI_GEDP_BG_COLOR_SRC_BG	0x0000
		#define ATI_GEDP_BG_COLOR_SRC_FG	0x0080
		#define ATI_GEDP_BG_COLOR_SRC_PTR	0x0100
		#define ATI_GEDP_BG_COLOR_SRC_VBLT	0x0180
	#define ATI_GEDP_DATA_WIDTH		0x0200
	#define ATI_GEDP_LSB_FIRST		0x1000
	#define ATI_GEDP_FG_COLOR_SRC		0xe000
		#define ATI_GEDP_FG_COLOR_SRC_BG	0x0000
		#define ATI_GEDP_FG_COLOR_SRC_FG	0x2000
		#define ATI_GEDP_FG_COLOR_SRC_PTR	0x4000
		#define ATI_GEDP_FG_COLOR_SRC_VBLT	0x6000
		#define ATI_GEDP_FG_COLOR_SRC_PATT	0xa000
#define ATI_PATT_LENGTH		0xd2ee
	#define ATI_PATT_LENGTH_MASK		0x001f
	#define ATI_PATT_8X8_MONO		0x0080
	#define ATI_PATT_8X8_BLOCK		0x1000
#define ATI_PATT_INDEX		0xd6ee
#define ATI_R_SRC_X		0xdaee
#define ATI_EXT_SCISSOR_L	0xdaee
	#define ATI_EXT_SCISSOR_MASK		0xfff
#define ATI_R_SRC_Y		0xdeee
#define ATI_EXT_SCISSOR_T	0xdeee
#define ATI_EXT_SCISSOR_R	0xe2ee
#define ATI_EXT_SCISSOR_B	0xe6ee
#define ATI_DEST_CMP_FN		0xeeee
	#define ATI_DEST_CMP_FN_BYTE		0x0038
	#define ATI_DEST_CMP_FN_B		0x0038
	#define ATI_DEST_CMP_FN_G		0x0038
	#define ATI_DEST_CMP_FN_R		0x0038
	  /* Shift these to use with color fields */
		#define ATI_DEST_CMP_FN_0		0x0000
		#define ATI_DEST_CMP_FN_1		0x0008
		#define ATI_DEST_CMP_FN_GTE		0x0018
		#define ATI_DEST_CMP_FN_LT		0x0018
		#define ATI_DEST_CMP_FN_NE		0x0021
		#define ATI_DEST_CMP_FN_EQ		0x0028
		#define ATI_DEST_CMP_FN_LTE		0x0031
		#define ATI_DEST_CMP_FN_GT		0x0038
#define ATI_LINEDRAW		0xfeee


#endif /* Not defined _ATI_38800_h */



